#include <stdio.h>
#include <stdlib.h>

main(argc,argv)
int argc;
char *argv[];
{
   FILE *f1,*f2;
   unsigned long n, from;
   int equal, c1,c2;

   if ((f1 = fopen(argv[1], "rb")) == NULL) {
      printf("Can't open f1");  exit(1);
      }
   if ((f2 = fopen(argv[2], "rb")) == NULL) {
      printf("Can't open f2");  exit(2);
      }
   from = n = 0;  equal = 0; 
   c1 = fgetc(f1);  c2 = fgetc(f2);
   if (c1 != EOF && c2 != EOF) {
      equal = c1 == c2;
      for (;;) {
         if (equal) {
            if (c1 != c2) {
               if (n != 0) printf("  same:    0x%lx .. 0x%lx   %lu(%lu)\n",
                  from, n-1, from, n-from);
               equal = 0;  from = n;
               }
            }
         else {  /* Not equal */
            if (c1 == c2) {
               printf("  DIFFER:  0x%lx .. 0x%lx   %lu(%lu)\n",
                  from, n-1, from, n-from);
               equal = 1;  from = n;
               }
            }
         c1 = fgetc(f1);  c2 = fgetc(f2);
         if (c1 == EOF || c2 == EOF) break;
         ++n;
         }
      }
   if (equal) printf("  same:    0x%lx .. 0x%lx   %lu(%lu)\n",
     from, n-1, from, n-from);
   else printf("  DIFFER:  0x%lx .. 0x%lx   %lu(%lu)\n",
     from, n-1, from, n-from);

   printf("%lx [%lu] bytes compared\n", n,n);
   
   if ((c1 == EOF && c2 != EOF) || (c1 != EOF && c2 == EOF))
      printf(">>> File lengths differ!\n");

   fclose(f1);  fclose(f2);
   }
