#include <conio.h>                  // getch()
#include "..\types\types.h"
#include "..\dpmi32\phys.h"


int main( void )
{
    // test code for physical memory addressing
    //
    Bit8 *video;
    Bit32 mem_handle;

    // map 32k of physical memory from B8000 to BFFFF into our
    // process's address space so that it's addressable via DS
    //
    video = (Bit8 *) map_physical( 0x000B8000, 0x00008000, &mem_handle );

    // change the character in the top, left corner
    // of the screen to be uppercase "U"
    //
    video[ 0 ] = 'U';

    // change the attribute byte of the character
    // in the top, left corner of the screen to be
    // black on white (reverse video)
    //
    video[ 1 ] = 0x70;

    // wait for keystroke
    //
    getch();

    // cleanup for physical memory access
    //
    unmap_physical( 0x00020000, mem_handle );

    return 0;
}
