#ifndef _netinet_tcp_seq_h
#define _netinet_tcp_seq_h

#include "../types/types.h"



/*
 * TCP sequence numbers are 32 bit integers operated
 * on with modular arithmetic.  These macros can be
 * used to compare such integers.
 */
#define SEQ_LT(a,b)     ((Signed32)((a)-(b)) <  0)
#define SEQ_LEQ(a,b)    ((Signed32)((a)-(b)) <= 0)
#define SEQ_GT(a,b)     ((Signed32)((a)-(b)) >  0)
#define SEQ_GEQ(a,b)    ((Signed32)((a)-(b)) >= 0)

#endif /*!_netinet_tcp_seq_h*/
