#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>

#include "../types/types.h"
#include "../intel/timestmp.h"
#include "../wattcp/tcp.h"

int main(int argc, char *argv[])
{
   PentiumClock now;
   double s1,s2;
   int j,k;
   Bit32 t1,t2;

//   hwt_init();  /* Now done in PentiumClock::init() */
   now.set();
   s1 = now.get_seconds();
#define TI_1  1
   t1 = set_timeout(TI_1);
   for (j = 0; j != 20; ++j) {
      printf("Waiting for %lu:  ", t1);
      while (!chk_timeout(t1)) ;
      now.set();
      s2 = now.get_seconds();
      t2 = set_timeout(TI_1);
#ifdef CLK_86
      printf("   BTC = %lu, now = %f\n", *bios_tick_counter, s2);
#else
      printf("   now = %f\n", s2);
#endif
      s1 = s2;  t1 = t2;
      }

#if 0
   for (j = 0; j != 10; ++j) {
      now.set();
      s1 = now.get_seconds();
#ifdef CLK_86
      printf("BTC = %lu, now = %f\n", *bios_tick_counter, s1);
#else
      printf("now = %f\n", s1);
#endif
      for (k = 0; k != 30000; ++k) now.set();
      for (k = 0; k != 30000; ++k) now.set();
      for (k = 0; k != 30000; ++k) now.set();
      for (k = 0; k != 30000; ++k) now.set();
      for (k = 0; k != 30000; ++k) now.set();
      for (k = 0; k != 30000; ++k) now.set();
      }
#endif

   hwt_fin();
   }
